diff --git a/web/pgadmin/tools/psql/static/js/psql_module.js b/web/pgadmin/tools/psql/static/js/psql_module.js
new file mode 100644
index 00000000..6223c697
--- /dev/null
+++ b/web/pgadmin/tools/psql/static/js/psql_module.js
@@ -0,0 +1,331 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2021, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import { Terminal } from 'xterm';
+import { FitAddon } from 'xterm-addon-fit';
+import { WebLinksAddon } from 'xterm-addon-web-links';
+import { SearchAddon } from 'xterm-addon-search';
+import { io } from 'socketio';
+import Alertify from 'pgadmin.alertifyjs';
+import {enable} from 'pgadmin.browser.toolbar';
+import clipboard from 'sources/selection/clipboard';
+import 'wcdocker';
+import {getRandomInt} from 'sources/utils';
+
+import {getTreeNodeHierarchyFromIdentifier} from 'sources/tree/pgadmin_tree_node';
+import {generateTitle} from 'tools/datagrid/static/js/datagrid_panel_title';
+
+
+export function setPanelTitle(psqlToolPanel, panelTitle) {
+  psqlToolPanel.title('<span title="'+panelTitle+'">'+panelTitle+'</span>');
+}
+
+var wcDocker = window.wcDocker;
+
+export function initialize(gettext, url_for, $, _, pgAdmin, csrfToken, Browser) {
+  var pgBrowser = Browser;
+  var terminal = Terminal;
+  var parentData = null;
+  /* Return back, this has been called more than once */
+  if (pgBrowser.psql)
+    return pgBrowser.psql;
+
+
+  // Create an Object Restore of pgBrowser class
+  pgBrowser.psql = {
+    init: function() {
+      this.initialized = true;
+      csrfToken.setPGCSRFToken(pgAdmin.csrf_token_header, pgAdmin.csrf_token);
+      // Define the nodes on which the menus to be appear
+      var menus = [{
+        name: 'psql',
+        module: this,
+        applies: ['tools'],
+        callback: 'psql_tool',
+        priority: 1,
+        label: gettext('PSQL Tool (Beta)'),
+        enable: this.psqlToolEnabled,
+      }];
+
+      this.enable_psql_tool = pgAdmin['enable_psql'];
+      if(pgAdmin['enable_psql']) {
+        pgBrowser.add_menus(menus);
+      }
+
+      // Creating a new pgBrowser frame to show the data.
+      var psqlFrameType = new pgBrowser.Frame({
+        name: 'frm_psqltool',
+        showTitle: true,
+        isCloseable: true,
+        isPrivate: true,
+        url: 'about:blank',
+      });
+
+      var self = this;
+      /* Cache may take time to load for the first time
+       * Keep trying till available
+       */
+      let cacheIntervalId = setInterval(function() {
+        if(pgBrowser.preference_version() > 0) {
+          self.preferences = pgBrowser.get_preferences_for_module('psql');
+          clearInterval(cacheIntervalId);
+        }
+      },0);
+
+      pgBrowser.onPreferencesChange('psql', function() {
+        self.preferences = pgBrowser.get_preferences_for_module('psql');
+      });
+
+      // Load the newly created frame
+      psqlFrameType.load(pgBrowser.docker);
+      return this;
+    },
+    /* Enable/disable PSQL tool menu in tools based
+    * on node selected. if selected node is present
+    * in unsupported_nodes, menu will be disabled
+    * otherwise enabled.
+    */
+    psqlToolEnabled: function(obj) {
+
+      var isEnabled = (() => {
+        if (!_.isUndefined(obj) && !_.isNull(obj)) {
+          if (_.indexOf(pgAdmin.unsupported_nodes, obj._type) == -1 || (obj._type == 'server' && obj.connected)) {
+            if (obj._type == 'database' && obj.allowConn) {
+              return true;
+            } else if (obj._type != 'database') {
+              return true;
+            } else {
+              return false;
+            }
+          } else {
+            return false;
+          }
+        } else {
+          return false;
+        }
+      })();
+
+      enable(gettext('PSQL Tool'), isEnabled);
+      return isEnabled;
+    },
+    retrieveAncestorOfTypeServer: function(item) {
+      let serverInformation = null;
+      // let aciTreeItem = item || pgBrowser.treeMenu.selected();
+      let treeNode = pgBrowser.treeMenu.findNodeByDomElement(item);
+
+      if (treeNode) {
+        let nodeData;
+        let databaseNode = treeNode.ancestorNode(
+          (node) => {
+            nodeData = node.getData();
+            return (nodeData._type === 'database');
+          }
+        );
+        let isServerNode = (node) => {
+          nodeData = node.getData();
+          return nodeData._type === 'server';
+        };
+
+        if (databaseNode !== null) {
+          if (nodeData._label.indexOf('=') >= 0) {
+            this.alertify.alert(
+              gettext(this.errorAlertTitle),
+              gettext(
+                'Databases with = symbols in the name cannot be backed up or restored using this utility.'
+              )
+            );
+          } else {
+            if (databaseNode.anyParent(isServerNode))
+              serverInformation = nodeData;
+          }
+        } else {
+          if (treeNode.anyFamilyMember(isServerNode))
+            serverInformation = nodeData;
+        }
+      }
+
+      if (serverInformation === null) {
+        this.alertify.alert(
+          gettext(this.errorAlertTitle),
+          gettext('Please select server or child node from the browser tree.')
+        );
+      }
+      return serverInformation;
+    },
+    psql_tool: function(data, aciTreeIdentifier, gen=false) {
+      const module = 'paths';
+      let preference_name = 'pg_bin_dir';
+      let msg = gettext('Please configure the PostgreSQL Binary Path in the Preferences dialog.');
+      const serverInformation = this.retrieveAncestorOfTypeServer(aciTreeIdentifier);
+
+      if ((serverInformation.type && serverInformation.type === 'ppas') ||
+        serverInformation.server_type === 'ppas') {
+        preference_name = 'ppas_bin_dir';
+        msg = gettext('Please configure the EDB Advanced Server Binary Path in the Preferences dialog.');
+      }
+      const preference = pgBrowser.get_preference(module, preference_name);
+      if (preference) {
+        if (!preference.value) {
+          Alertify.alert(gettext('Configuration required'), msg);
+          return false;
+        }
+      } else {
+        Alertify.alert(
+          gettext(this.errorAlertTitle),
+          gettext('Failed to load preference %s of module %s', preference_name, module)
+        );
+        return false;
+      }
+      const node = pgBrowser.treeMenu.findNodeByDomElement(aciTreeIdentifier);
+      if (node === undefined || !node.getData()) {
+        Alertify.alert(
+          gettext('PSQL Error'),
+          gettext('No object selected.')
+        );
+        return;
+      }
+
+      parentData = getTreeNodeHierarchyFromIdentifier.call(
+        pgBrowser,
+        aciTreeIdentifier
+      );
+
+      if(_.isUndefined(parentData.server)) {
+        Alertify.alert(
+          gettext('PSQL Error'),
+          gettext('Please select a server/database object.')
+        );
+        return;
+      }
+
+      const transId = getRandomInt(1, 9999999);
+
+      var panelTitle = '';
+      // Set psql tab title as per prefrences setting.
+      var title_data = {
+        'database': parentData.database ? parentData.database.label : 'postgres' ,
+        'username': parentData.server.user_name,
+        'server': parentData.server.label,
+        'type': 'psql_tool',
+      };
+      var tab_title_placeholder = pgBrowser.get_preferences_for_module('browser').psql_tab_title_placeholder;
+      panelTitle = generateTitle(tab_title_placeholder, title_data);
+
+      const [panelUrl, panelCloseUrl] = this.getPanelUrls(transId, panelTitle, parentData, gen);
+
+      let psqlToolForm = `
+        <form id="psqlToolForm" action="${panelUrl}" method="post">
+          <input id="title" name="title" hidden />
+          <input name="close_url" value="${panelCloseUrl}" hidden />
+        </form>
+        <script>
+          document.getElementById("title").value = "${_.escape(panelTitle)}";
+          document.getElementById("psqlToolForm").submit();
+        </script>
+      `;
+      var open_new_tab = pgBrowser.get_preferences_for_module('browser').new_browser_tab_open;
+      if (open_new_tab && open_new_tab.includes('psql_tool')) {
+        var newWin = window.open('', '_blank');
+        newWin.document.write(psqlToolForm);
+        newWin.document.title = panelTitle;
+      } else {
+        /* On successfully initialization find the properties panel,
+         * create new panel and add it to the dashboard panel.
+         */
+        var propertiesPanel = pgBrowser.docker.findPanels('properties');
+        var psqlToolPanel = pgBrowser.docker.addPanel('frm_psqltool', wcDocker.DOCK.STACKED, propertiesPanel[0]);
+
+        // Set panel title and icon
+        setPanelTitle(psqlToolPanel, panelTitle);
+        psqlToolPanel.icon('fas fa-terminal psql-tab-style');
+        psqlToolPanel.focus();
+
+        var openPSQLToolURL = function(j) {
+          // add spinner element
+          let $spinner_el =
+            $(`<div class="pg-sp-container">
+                  <div class="pg-sp-content">
+                      <div class="row">
+                          <div class="col-12 pg-sp-icon"></div>
+                      </div>
+                  </div>
+              </div>`).appendTo($(j).data('embeddedFrame').$container);
+
+          let init_poller_id = setInterval(function() {
+            var frameInitialized = $(j).data('frameInitialized');
+            if (frameInitialized) {
+              clearInterval(init_poller_id);
+              var frame = $(j).data('embeddedFrame');
+              if (frame) {
+                frame.onLoaded(()=>{
+                  $spinner_el.remove();
+                });
+                frame.openHTML(psqlToolForm);
+              }
+            }
+          }, 100);
+        };
+
+        openPSQLToolURL(psqlToolPanel);
+
+      }
+
+    },
+    getPanelUrls: function(transId, panelTitle, parentData) {
+      let openUrl = url_for('psql.panel', {
+        trans_id: transId,
+      });
+      const misc_preferences = pgBrowser.get_preferences_for_module('misc');
+      var theme = misc_preferences.theme;
+
+      openUrl += `?sgid=${parentData.server_group._id}`
+        +`&sid=${parentData.server._id}`
+        +`&server_type=${parentData.server.server_type}`
+        + `&theme=${theme}`;
+
+      if(parentData.database && parentData.database._id) {
+        let db_label = parentData.database._label.replace('\\', '\\\\');
+        openUrl += `&db=${_.escape(db_label)}`;
+      } else {
+        openUrl += `&db=${''}`;
+      }
+
+      let closeUrl = url_for('psql.close', {
+        trans_id: transId,
+      });
+      return [openUrl, closeUrl];
+    },
+    psql_terminal: function() {
+      // theme colors
+      var term = new terminal({
+        cursorBlink: true,
+        macOptionIsMeta: true,
+        scrollback: 10000,
+      });
+      return term;
+    },
+    psql_fit_screen: function() {
+      return new FitAddon();
+    },
+    psql_web_link: function() {
+      return new WebLinksAddon();
+    },
+    psql_search: function() {
+      return new SearchAddon();
+    },
+    psql_socket: function() {
+      return io('/pty', {pingTimeout: 120000, pingInterval: 25000});
+    },
+    _clipboard: function() {
+      return clipboard;
+    }
+  };
+
+  return pgBrowser.psql;
+}
+
diff --git a/web/pgadmin/tools/psql/tests/test_backend_task.py b/web/pgadmin/tools/psql/tests/test_backend_task.py
new file mode 100644
index 00000000..a4f14ee4
--- /dev/null
+++ b/web/pgadmin/tools/psql/tests/test_backend_task.py
@@ -0,0 +1,87 @@
+import uuid
+import config
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from regression import parent_node_dict
+from regression.test_setup import config_data
+from pgadmin.utils import server_utils as server_utils
+from pgAdmin4 import app
+from . import utils as psql_utils
+from .... import socketio
+
+
+class PSQLBackend(BaseTestGenerator):
+    scenarios = utils.generate_scenarios('backend_task',
+                                         psql_utils.test_cases)
+
+    def setUp(self):
+        self.db_name = "psqltestdb_{0}".format(str(uuid.uuid4())[1:8])
+        database_info = parent_node_dict["database"][-1]
+        self.did = database_info["db_id"]
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.sgid = config_data["server_group"]
+        config.ENABLE_PSQL = True
+        self.server_con = server_utils.connect_server(self, self.sid)
+
+    def runTest(self):
+        # Fetch flask client to access current user and other cookies.
+        flask_client = app.test_client()
+        flask_client.get('/')
+        self.test_client = socketio.test_client(app, namespace='/pty',
+                                                flask_test_client=flask_client)
+        self.assertTrue(self.test_client.is_connected('/pty'))
+        received = self.test_client.get_received('/pty')
+
+        assert received[0]['name'] == 'connected'
+        assert received[0]['args'][0]['sid'] != ''
+
+        data = {
+            'sid': self.sid,
+            'db': 'postgres',
+            'pwd': self.server['db_password'],
+            'user': self.server['username'],
+            'is_test': True,
+            'count': 0
+        }
+
+        self.test_client.emit('start_process', data, namespace='/pty')
+        self.test_client.get_received('/pty')
+
+        for p in self.server['db_password']:
+            input_data = {
+                'input': p,
+                'key_name': 'Key{0}'.format(p)
+            }
+            self.test_client.emit('socket_input', input_data, namespace='/pty')
+            self.test_client.get_received('/pty')
+
+        input_data = {
+            'input': '\\n',
+            'key_name': 'Enter'
+        }
+        self.test_client.emit('socket_input', input_data, namespace='/pty')
+        self.test_client.get_received('/pty')
+
+        for ip in self.input_cmd:
+            input_data = {
+                'input': ip,
+                'key_name': 'Key{0}'.format(ip)
+            }
+            self.test_client.emit('socket_input', input_data, namespace='/pty')
+            self.test_client.get_received('/pty')
+
+        input_data = {
+            'input': '\\n',
+            'key_name': 'Enter'
+        }
+        self.test_client.emit('socket_input', input_data, namespace='/pty')
+        self.test_client.get_received('/pty')
+        self.test_client.disconnect(namespace='/pty')
+
+    def tearDown(self):
+        connection = utils.get_db_connection(self.server['db'],
+                                             self.server['username'],
+                                             self.server['db_password'],
+                                             self.server['host'],
+                                             self.server['port'])
+        utils.drop_database(connection, self.db_name)
diff --git a/web/pgadmin/tools/psql/tests/test_panel.py b/web/pgadmin/tools/psql/tests/test_panel.py
new file mode 100644
index 00000000..6f93c8c2
--- /dev/null
+++ b/web/pgadmin/tools/psql/tests/test_panel.py
@@ -0,0 +1,36 @@
+import uuid
+import random
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from regression import parent_node_dict
+from regression.test_setup import config_data
+
+
+class PSQLPanel(BaseTestGenerator):
+
+    def setUp(self):
+        self.db_name = "psqltestdb_{0}".format(str(uuid.uuid4())[1:8])
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.did = utils.create_database(self.server, self.db_name)
+        self.sgid = config_data["server_group"]
+        self.theme = 'standard'
+
+    def runTest(self):
+        trans_id = random.randint(1, 9999999)
+        url = '/psql/panel/{trans_id}?sgid={sgid}&sid={sid}&server_type=pg' \
+              '&db={db_name}&theme={theme}'.\
+            format(trans_id=trans_id, sgid=self.sgid, sid=self.sid,
+                   db_name=self.db_name, theme=self.theme)
+
+        response = self.tester.post(
+            url, data={"title": "panel_title"},
+            content_type="application/x-www-form-urlencoded")
+        self.assertEqual(response.status_code, 200)
+
+    def tearDown(self):
+        connection = utils.get_db_connection(self.server['db'],
+                                             self.server['username'],
+                                             self.server['db_password'],
+                                             self.server['host'],
+                                             self.server['port'])
+        utils.drop_database(connection, self.db_name)
diff --git a/web/pgadmin/tools/psql/tests/test_psql_disabled.py b/web/pgadmin/tools/psql/tests/test_psql_disabled.py
new file mode 100644
index 00000000..7dc52498
--- /dev/null
+++ b/web/pgadmin/tools/psql/tests/test_psql_disabled.py
@@ -0,0 +1,34 @@
+import uuid
+import config
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from regression import parent_node_dict
+from regression.test_setup import config_data
+from pgAdmin4 import app
+from .... import socketio
+
+
+class PSQLSocketDisabled(BaseTestGenerator):
+    def setUp(self):
+        self.db_name = "psqltestdb_{0}".format(str(uuid.uuid4())[1:8])
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.did = utils.create_database(self.server, self.db_name)
+        self.sgid = config_data["server_group"]
+        config.ENABLE_PSQL = False
+
+    def runTest(self):
+        self.test_client = socketio.test_client(app, namespace='/pty')
+        self.assertTrue(self.test_client.is_connected('/pty'))
+        received = self.test_client.get_received('/pty')
+
+        assert received[0]['name'] == 'conn_not_allow'
+        self.test_client.disconnect(namespace='/pty')
+        self.assertFalse(self.test_client.is_connected('/pty'))
+
+    def tearDown(self):
+        connection = utils.get_db_connection(self.server['db'],
+                                             self.server['username'],
+                                             self.server['db_password'],
+                                             self.server['host'],
+                                             self.server['port'])
+        utils.drop_database(connection, self.db_name)
diff --git a/web/pgadmin/tools/psql/tests/test_psql_input.py b/web/pgadmin/tools/psql/tests/test_psql_input.py
new file mode 100644
index 00000000..6f6eabe7
--- /dev/null
+++ b/web/pgadmin/tools/psql/tests/test_psql_input.py
@@ -0,0 +1,148 @@
+import uuid
+import config
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from regression import parent_node_dict
+from regression.test_setup import config_data
+from pgadmin.utils import server_utils as server_utils
+from pgAdmin4 import app
+from . import utils as psql_utils
+from .... import socketio
+
+
+class PSQLInput(BaseTestGenerator):
+    scenarios = utils.generate_scenarios('psql_user_input',
+                                         psql_utils.test_cases)
+
+    def setUp(self):
+        self.db_name = "psqltestdb_{0}".format(str(uuid.uuid4())[1:8])
+        database_info = parent_node_dict["database"][-1]
+        self.did = database_info["db_id"]
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.sgid = config_data["server_group"]
+        config.ENABLE_PSQL = True
+        self.server_con = server_utils.connect_server(self, self.sid)
+
+    def runTest(self):
+        # Fetch flask client to access current user and other cookies.
+        flask_client = app.test_client()
+        flask_client.get('/')
+        self.test_client = socketio.test_client(app, namespace='/pty',
+                                                flask_test_client=flask_client)
+        self.assertTrue(self.test_client.is_connected('/pty'))
+        received = self.test_client.get_received('/pty')
+
+        assert received[0]['name'] == 'connected'
+        assert received[0]['args'][0]['sid'] != ''
+
+        data = {
+            'sid': self.sid,
+            'db': 'postgres',
+            'pwd': self.server['db_password'],
+            'user': self.server['username']
+        }
+
+        self.test_client.emit('start_process', data, namespace='/pty')
+        self.test_client.get_received('/pty')
+
+        input_data = {
+            'input': '\\n',
+            'key_name': 'Enter'
+        }
+        self.test_client.emit('socket_input', input_data, namespace='/pty')
+        self.test_client.get_received('/pty')
+
+        for ip in self.input_cmd:
+            input_data = {
+                'input': ip,
+                'key_name': 'Key{0}'.format(ip)
+            }
+            self.test_client.emit('socket_input', input_data, namespace='/pty')
+            self.test_client.get_received('/pty')
+
+        if hasattr(self, 'is_backspace') and self.is_backspace:
+            if hasattr(self, 'move_cursor_up') and self.move_cursor_up:
+                input_data = {
+                    'input': '',
+                    'key_name': 'ArrowUp'
+                }
+                self.test_client.emit('socket_input', input_data,
+                                      namespace='/pty')
+
+            for ip in self.input_cmd:
+                input_data = {
+                    'input': ip,
+                    'key_name': 'Backspace'
+                }
+                self.test_client.emit('socket_input', input_data,
+                                      namespace='/pty')
+                self.test_client.get_received('/pty')
+
+        if hasattr(self, 'is_arrowUp') and self.is_arrowUp:
+            if hasattr(self, 'is_history') and self.is_history:
+                for ip in self.input_cmd:
+                    input_data = {
+                        'input': ip,
+                        'key_name': 'Key{0}'.format(ip)
+                    }
+                    self.test_client.emit('socket_input', input_data,
+                                          namespace='/pty')
+                    self.test_client.get_received('/pty')
+
+            input_data = {
+                'input': '',
+                'key_name': 'ArrowUp'
+            }
+            self.test_client.emit('socket_input', input_data,
+                                  namespace='/pty')
+            self.test_client.get_received('/pty')
+
+        if hasattr(self, 'is_arrowLeft') and self.is_arrowLeft:
+            for ip in self.input_cmd:
+                input_data = {
+                    'input': ip,
+                    'key_name': 'ArrowLeft'
+                }
+                self.test_client.emit('socket_input', input_data,
+                                      namespace='/pty')
+                self.test_client.get_received('/pty')
+
+        if hasattr(self, 'is_arrowRight') and self.is_arrowRight:
+            for ip in self.input_cmd:
+                input_data = {
+                    'input': ip,
+                    'key_name': 'ArrowRight'
+                }
+                self.test_client.emit('socket_input', input_data,
+                                      namespace='/pty')
+                self.test_client.get_received('/pty')
+
+            if hasattr(self, 'move_cursor_right') and self.is_arrowRight:
+                for i in range(2):
+                    input_data = {
+                        'input': '',
+                        'key_name': 'ArrowLeft'
+                    }
+                    self.test_client.emit('socket_input', input_data,
+                                          namespace='/pty')
+                input_data = {
+                    'input': '',
+                    'key_name': 'ArrowRight'
+                }
+                self.test_client.emit('socket_input', input_data,
+                                      namespace='/pty')
+
+        input_data = {
+            'input': '\\n',
+            'key_name': 'Enter'
+        }
+        self.test_client.emit('socket_input', input_data, namespace='/pty')
+        self.test_client.get_received('/pty')
+
+    def tearDown(self):
+        connection = utils.get_db_connection(self.server['db'],
+                                             self.server['username'],
+                                             self.server['db_password'],
+                                             self.server['host'],
+                                             self.server['port'])
+        utils.drop_database(connection, self.db_name)
diff --git a/web/pgadmin/tools/psql/tests/test_resize_terminal.py b/web/pgadmin/tools/psql/tests/test_resize_terminal.py
new file mode 100644
index 00000000..d305c2d0
--- /dev/null
+++ b/web/pgadmin/tools/psql/tests/test_resize_terminal.py
@@ -0,0 +1,58 @@
+import uuid
+import config
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from regression import parent_node_dict
+from regression.test_setup import config_data
+from pgadmin.utils import server_utils as server_utils
+from pgAdmin4 import app
+from . import utils as psql_utils
+from .... import socketio
+
+
+class PSQLResizeTerminal(BaseTestGenerator):
+    scenarios = utils.generate_scenarios('resize_terminal',
+                                         psql_utils.test_cases)
+
+    def setUp(self):
+        self.db_name = "psqltestdb_{0}".format(str(uuid.uuid4())[1:8])
+        database_info = parent_node_dict["database"][-1]
+        self.did = database_info["db_id"]
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.sgid = config_data["server_group"]
+        config.ENABLE_PSQL = True
+        self.server_con = server_utils.connect_server(self, self.sid)
+
+    def runTest(self):
+        # Fetch flask client to access current user and other cookies.
+        flask_client = app.test_client()
+        flask_client.get('/')
+        self.test_client = socketio.test_client(app, namespace='/pty',
+                                                flask_test_client=flask_client)
+        self.assertTrue(self.test_client.is_connected('/pty'))
+        received = self.test_client.get_received('/pty')
+
+        assert received[0]['name'] == 'connected'
+        assert received[0]['args'][0]['sid'] != ''
+
+        data = {
+            'sid': self.sid,
+            'db': 'postgres',
+            'pwd': self.server['db_password'],
+            'user': self.server['username']
+        }
+
+        self.test_client.emit('start_process', data, namespace='/pty')
+        self.test_client.get_received('/pty')
+
+        self.test_client.emit('resize', self.input_data, namespace='/pty')
+
+        self.test_client.disconnect(namespace='/pty')
+
+    def tearDown(self):
+        connection = utils.get_db_connection(self.server['db'],
+                                             self.server['username'],
+                                             self.server['db_password'],
+                                             self.server['host'],
+                                             self.server['port'])
+        utils.drop_database(connection, self.db_name)
diff --git a/web/pgadmin/tools/psql/tests/test_socket_connect.py b/web/pgadmin/tools/psql/tests/test_socket_connect.py
new file mode 100644
index 00000000..3791525a
--- /dev/null
+++ b/web/pgadmin/tools/psql/tests/test_socket_connect.py
@@ -0,0 +1,35 @@
+import uuid
+import config
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from regression import parent_node_dict
+from regression.test_setup import config_data
+from pgAdmin4 import app
+from .... import socketio
+
+
+class PSQLSocketConnect(BaseTestGenerator):
+    def setUp(self):
+        self.db_name = "psqltestdb_{0}".format(str(uuid.uuid4())[1:8])
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.did = utils.create_database(self.server, self.db_name)
+        self.sgid = config_data["server_group"]
+        config.ENABLE_PSQL = True
+
+    def runTest(self):
+        self.test_client = socketio.test_client(app, namespace='/pty')
+        self.assertTrue(self.test_client.is_connected('/pty'))
+        received = self.test_client.get_received('/pty')
+
+        assert received[0]['name'] == 'connected'
+        assert received[0]['args'][0]['sid'] != ''
+        self.test_client.disconnect(namespace='/pty')
+        self.assertFalse(self.test_client.is_connected('/pty'))
+
+    def tearDown(self):
+        connection = utils.get_db_connection(self.server['db'],
+                                             self.server['username'],
+                                             self.server['db_password'],
+                                             self.server['host'],
+                                             self.server['port'])
+        utils.drop_database(connection, self.db_name)
diff --git a/web/pgadmin/tools/psql/tests/test_socket_disconnect.py b/web/pgadmin/tools/psql/tests/test_socket_disconnect.py
new file mode 100644
index 00000000..0619eb30
--- /dev/null
+++ b/web/pgadmin/tools/psql/tests/test_socket_disconnect.py
@@ -0,0 +1,52 @@
+import uuid
+import config
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from regression import parent_node_dict
+from regression.test_setup import config_data
+from pgAdmin4 import app
+from .... import socketio
+
+
+class PSQLSocketDisconnect(BaseTestGenerator):
+    def setUp(self):
+        self.db_name = "psqltestdb_{0}".format(str(uuid.uuid4())[1:8])
+        self.sid = parent_node_dict["server"][-1]["server_id"]
+        self.did = utils.create_database(self.server, self.db_name)
+        self.sgid = config_data["server_group"]
+        config.ENABLE_PSQL = True
+
+    def runTest(self):
+        # Fetch flask client to access current user and other cookies.
+        flask_test_client = app.test_client()
+        flask_test_client.get('/')
+
+        self.test_client = socketio.test_client(
+            app,
+            flask_test_client=flask_test_client,
+            namespace='/pty')
+        self.assertTrue(self.test_client.is_connected('/pty'))
+        received = self.test_client.get_received('/pty')
+
+        assert received[0]['name'] == 'connected'
+        assert received[0]['args'][0]['sid'] != ''
+
+        data = {
+            'sid': self.sid,
+            'db': 'postgres',
+            'pwd': self.server['db_password'],
+            'user': self.server['username']
+        }
+
+        self.test_client.emit('start_process', data, namespace='/pty')
+        self.test_client.get_received('/pty')
+
+        self.test_client.disconnect(namespace='/pty')
+
+    def tearDown(self):
+        connection = utils.get_db_connection(self.server['db'],
+                                             self.server['username'],
+                                             self.server['db_password'],
+                                             self.server['host'],
+                                             self.server['port'])
+        utils.drop_database(connection, self.db_name)
